float4 vecSkill41;
float4 vecSkill1;
float4 vecSkill5;

float4x4 matWorldViewProj;
float4x4 matWorld;

float4 vecTime;

float4 vecSunDir;		

float4 vecAmbient;


texture mtlSkin1;
texture mtlSkin2;

sampler DepthMapSampler = sampler_state
{
	Texture   = <mtlSkin2>;  
	AddressU  = clamp;
	AddressV  = clamp;
};

sampler ColorMapSampler = sampler_state
{
	Texture   = <mtlSkin1>;
	MinFilter = Linear;
	MagFilter = Linear;
	MipFilter = Linear;   
	AddressU  = wrap;
	AddressV  = wrap;
};



void SoftVS(		
in float4 vPos		   : POSITION,
in float2 InTex	   : TEXCOORD0,

out float2 OutTex	      : TEXCOORD0,		
out float4 pPos		   : TEXCOORD1,
out float3 wPos 		   : TEXCOORD2,

out float4 Pos	         : POSITION
)
{
	
	Pos = mul(vPos,matWorldViewProj);
	
	pPos=Pos;
	
	OutTex          = InTex;

	wPos   = mul(vPos,matWorld);

}


float4 SoftPS(	
in float2 InTex		     : TEXCOORD0,    
in float4 pPos		        : TEXCOORD1,
in float3 wPos 		     : TEXCOORD2

) : COLOR
{

	float4 c;
	float  alpha_mask,depth_off1,depth_off2,depth_off=1;
	
	//	InTex.y/=1.33f;
	
	alpha_mask=tex2D(ColorMapSampler,InTex).a;
	
	if(vecSkill1.y==1)
	{
		depth_off1=tex2D(ColorMapSampler,float2(InTex.x+(vecTime.w*0.01f*vecSkill41.y),InTex.y+(vecTime.w*0.01f*vecSkill41.z))).r;
		depth_off2=tex2D(ColorMapSampler,float2(InTex.x+(vecTime.w*0.01f*-vecSkill41.z),InTex.y+(vecTime.w*0.01f*vecSkill41.y))).r;
		
		depth_off=depth_off1*depth_off2;
	}
	c.rgb=depth_off1;

	///////////////////////////////////
	float3 eye;
	eye.x = 0.5 * (pPos.w + pPos.x);
	eye.y = 0.5 * (pPos.w - pPos.y);
	eye.z = pPos.w * 1;
	
	
	float2 mid;

	mid= eye.xy / eye.z;

	float obj_depth=tex2D(DepthMapSampler,mid).r;
	///////////////////////////////////	
		
	float blend=vecSkill1.w;
	
	float Kdoff=vecSkill1.z;
	
	float add_depth=(1-depth_off)*Kdoff;
	
	c.w=1;
	
	//	if(obj_depth+1>=pPos.z)
	c.w=lerp(0,1,saturate(saturate(obj_depth/blend-((pPos.z+add_depth)/blend))));
	
	c.w*=alpha_mask*saturate(depth_off+(1-vecSkill5.y))*saturate(pPos.z/vecSkill5.x);

	c.w=saturate(c.w-0.01f*(100.f-vecSkill41.w));
	
	c.rgb=0.6f+c.rgb/10.f;

	float3 Ka=vecAmbient.xyz;


	if(vecSkill1.x==1)//pseudo lighting
	{
		float Kd=0.01f*vecSkill5.z;
		
		float y_light=(-wPos.y*vecSunDir.y)/400+2.2f;
		y_light=exp(y_light)*Kd;

		float x_light=(-wPos.z*vecSunDir.z)/50+3;
		x_light=exp(x_light)*Kd;

		float z_light=(-wPos.x*vecSunDir.x)/50+3;
		z_light=exp(z_light)*Kd;

		Ka*=x_light*z_light*y_light*vecSkill5.w;	
	}

	c.rgb*=Ka;

	return c;
}

technique SoftTechnique
{
	pass P0
	{
		VertexShader = compile vs_1_1 SoftVS();
		PixelShader  = compile ps_2_0 SoftPS();
	}
}